
.equ LCD_ON				= 0b00111111	;0x3F
.equ LCD_OFF			= 0b00111110	;0x3E
.equ LCD_START_LINE		= 0b11000000	;0xC0
.equ LCD_SET_PAGE		= 0b10111000	;0xB8
.equ LCD_SET_ADDRESS	= 0b01000000	;0x40

;**************************************************************************************
lcd_init:
	ldi		Daten, LCD_ON
	rcall	lcd_writecom
	rcall	delay500ms
	ldi		Daten, LCD_START_LINE	;Start Display Line = 0
	rcall	lcd_writecom
	rcall	delay500ms
	rcall	LCD_clear
	rcall	delay500ms
ret

;*****************************************************************************************
_LCD_ON:
	ldi		Daten, LCD_ON
	rcall	lcd_writecom
ret

;*****************************************************************************************
_LCD_OFF:
	ldi		Daten, LCD_OFF
	rcall	lcd_writecom
ret

;******************************************************************************************
LCD_clear:
	clr		temp
LCD_clear_1:	
	cbi		LCDC, CS1				;CS1 eingeschaltet
	sbi		LCDC, CS2				;CS2 ausgeschaltet
	ldi		Daten, LCD_SET_ADDRESS	;Y auf 0
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE		;Reihe auf 0
	or		Daten, temp				;Reihe aktualisieren
	rcall	lcd_writecom
	clr		Daten
	ldi		temp1, YSize			;64 Spalten
	rcall	LCD_clear_loop
	inc		temp
	cpi		temp, 8
	breq	LCD_c
rjmp	LCD_clear_1
LCD_c:
	clr		temp
LCD_clear_2:	
	sbi		LCDC, CS1				;CS1 ausgeschaltet
	cbi		LCDC, CS2				;CS2 eingeschaltet
	ldi		Daten, LCD_SET_ADDRESS	;Y auf 0
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE		;Reihe auf 0
	or		Daten, temp				;Reihe aktualisieren
	rcall	lcd_writecom
	clr		Daten
	ldi		temp1, YSize
	rcall	LCD_clear_loop
	inc		temp
	cpi		temp, 8
	breq	exit
rjmp	LCD_clear_2
LCD_clear_loop:
	rcall	lcd_writebyte
	dec		temp1
    brne	LCD_clear_loop
ret

;****************************************************************************************************
exit:
ret

;*************************************************************************************
lcd_writecom:
    cbi		LCDC, E				;E auf low
	cbi		LCDC, RW			;RW auf low fr schreiben
	cbi		LCDC, DI			;DI low fr Command
 	out		LCDD, Daten			;Command ausgeben
	rcall	delay5us
    sbi		LCDC, E				;E auf hugh
	rcall	delay5us
    cbi		LCDC, E				;E wieder auf low
	rcall	delay50us
ret

lcd_writebyte:
    cbi		LCDC, E				;E auf low
	cbi		LCDC, RW			;RW auf low fr schreiben
	sbi		LCDC, DI			;DI high fr Daten
 	out		LCDD, Daten			;Daten ausgeben
	rcall	delay5us
    sbi		LCDC, E				;E auf hugh
	rcall	delay5us
    cbi		LCDC, E				;E wieder auf low
	rcall	delay50us
ret

;***********************************************************************************************************
Bild_Aus:
;Ausgabe CO
	cbi		LCDC, CS1					;CS1 eingeschaltet
	sbi		LCDC, CS2					;CS2 ausgeschaltet
	ldi		Daten, LCD_SET_ADDRESS+1	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(C_font*2)
	ldi		ZH,High(C_font*2)
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Bild_Loop
	ldi		ZL,Low(O_font*2)
	ldi		ZH,High(O_font*2)
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Bild_Loop
;Ausgabe 2	
	ldi		Daten, LCD_SET_ADDRESS+1	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(C_font*2+14)
	ldi		ZH,High(C_font*2+14)
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Bild_Loop
	ldi		ZL,Low(O_font*2+14)
	ldi		ZH,High(O_font*2+14)
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Bild_Loop
	ldi		ZL,Low(S_font*2)
	ldi		ZH,High(S_font*2)
	ldi		temp, 8						;Anzahl der Bytes
	rcall	Bild_Loop
;Ausgabe ppm
	sbi		LCDC, CS1					;CS1 ausgeschaltet
	cbi		LCDC, CS2					;CS2 eingeschaltet
	ldi		Daten, LCD_SET_ADDRESS+37	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(ppm_1_font*2)
	ldi		ZH,High(ppm_1_font*2)
	ldi		temp, 24					;Anzahl der Bytes
	rcall	Bild_Loop
	ldi		Daten, LCD_SET_ADDRESS+37	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(ppm_2_font*2)
	ldi		ZH,High(ppm_2_font*2)
	ldi		temp, 24					;Anzahl der Bytes
	rcall	Bild_Loop
ret

;******************************************************************************************************************
Bild_Loop:
	lpm		Daten, Z+
	rcall	lcd_writebyte
	dec		temp
	breq	exit1
rjmp	Bild_Loop

;******************************************************************************************************************
exit1:
ret

;*****************************************************************************************************************
Leer:
	cbi		LCDC, CS1					;CS1 eingeschaltet
	sbi		LCDC, CS2					;CS2 ausgeschaltet
	ldi		Daten, LCD_SET_ADDRESS+41	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 14					;14 Leerbytes einfgen
	clr		Daten
	rcall	Leerloop
	rcall	lcd_writebyte
	ldi		Daten, LCD_SET_ADDRESS+41	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		temp, 14					;14 Leerbytes einfgen
	clr		Daten
	rcall	Leerloop
ret
Leerloop:
	rcall	lcd_writebyte
	dec		temp
	breq	exit1
rjmp	Leerloop	

Ziff_T:
	cbi		LCDC, CS1					;CS1 eingeschaltet
	sbi		LCDC, CS2					;CS2 ausgeschaltet
	cpi		temp1, 0
	breq	Leer						;wenn Tausender 0, dann raus
	ldi		Daten, LCD_SET_ADDRESS+41	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 28
	mul		temp1, temp
	ldi		ZL,Low(Ziffern*2)
	ldi		ZH,High(Ziffern*2)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
	ldi		Daten, LCD_SET_ADDRESS+41	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(Ziffern*2+14)
	ldi		ZH,High(Ziffern*2+14)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
ret

Ziff_H:									
;linke Hlfte
	cbi		LCDC, CS1					;CS1 eingeschaltet
	sbi		LCDC, CS2					;CS2 ausgeschaltet
	ldi		Daten, LCD_SET_ADDRESS+55	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 28
	mul		temp1, temp
	ldi		ZL,Low(Ziffern*2)
	ldi		ZH,High(Ziffern*2)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 9						;Anzahl der Bytes
	rcall	Ziff_loop
	ldi		Daten, LCD_SET_ADDRESS+55;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(Ziffern*2+14)
	ldi		ZH,High(Ziffern*2+14)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 9						;Anzahl der Bytes
	rcall	Ziff_loop
;rechte Hlfte				
	sbi		LCDC, CS1					;CS1 ausgeschaltet
	cbi		LCDC, CS2					;CS2 eingeschaltet
	ldi		Daten, LCD_SET_ADDRESS		;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 28
	mul		temp1, temp
	ldi		ZL,Low(Ziffern*2+9)
	ldi		ZH,High(Ziffern*2+9)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 5						;Anzahl der Bytes
	rcall	Ziff_loop
	ldi		Daten, LCD_SET_ADDRESS		;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(Ziffern*2+14+9)
	ldi		ZH,High(Ziffern*2+14+9)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 5						;Anzahl der Bytes
	rcall	Ziff_loop
ret

Ziff_Z:
	sbi		LCDC, CS1					;CS1 ausgeschaltet
	cbi		LCDC, CS2					;CS2 eingeschaltet
	ldi		Daten, LCD_SET_ADDRESS+5	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 28
	mul		temp1, temp
	ldi		ZL,Low(Ziffern*2)
	ldi		ZH,High(Ziffern*2)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
	ldi		Daten, LCD_SET_ADDRESS+5	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(Ziffern*2+14)
	ldi		ZH,High(Ziffern*2+14)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
ret

Ziff_E:
	ldi		Daten, LCD_SET_ADDRESS+19	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+1		;X setzen
	rcall	lcd_writecom
	ldi		temp, 28
	mul		temp1, temp
	ldi		ZL,Low(Ziffern*2)
	ldi		ZH,High(Ziffern*2)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
	ldi		Daten, LCD_SET_ADDRESS+19	;Y setzen
	rcall	lcd_writecom
	ldi		Daten, LCD_SET_PAGE+2		;X setzen
	rcall	lcd_writecom
	ldi		ZL,Low(Ziffern*2+14)
	ldi		ZH,High(Ziffern*2+14)
	add		ZL, R0
	adc		ZH, R1
	ldi		temp, 14					;Anzahl der Bytes
	rcall	Ziff_loop
ret

;******************************************************************************************************************
Ziff_loop:
	lpm		Daten, Z+
	rcall	lcd_writebyte
	dec		temp						
	breq	exit2
rjmp	Ziff_loop

;*************************************************************************************************
exit2:
ret
;*****************************************************************************************************************



C_font:	
.db	0x00,	0x00,	0x00,	0xF0,	0xFC,	0x0E,	0x07,	0x03,	0x03,	0x03,	0x07,	0x0E,	0x0C,	0x00		; C_1
.db	0x00,	0x00,	0x00,	0x03,	0x0F,	0x1C,	0x38,	0x30,	0x30,	0x30,	0x38,	0x1C,	0x0C,	0x00		; C_2		
O_font:
.db	0x00,	0x00,	0x00,	0xF0,	0xFC,	0x0E,	0x07,	0x03,	0x03,	0x07,	0x0E,	0xFC,	0xF0,	0x00		; O_1			
.db	0x00,	0x00,	0x00,	0x03,	0x0F,	0x1C,	0x38,	0x30,	0x30,	0x38,	0x1C,	0x0F,	0x03,	0x00		; O_2		
S_font:
.db	0x00,	0x62,	0x73,	0x59,	0x49,	0x6F,	0x66,	0x00		; 2			

ppm_1_font:	
.db	0x40,	0xC0,	0x80,	0x40,	0x40,	0xC0,	0x80,	0x00		; p_1		
.db	0x40,	0xC0,	0x80,	0x40,	0x40,	0xC0,	0x80,	0x00		; p_1		
.db	0xC0,	0xC0,	0x40,	0xC0,	0x40,	0xC0,	0x80,	0x00		; m_1		
ppm_2_font:
.db	0x20,	0x3F,	0x3F,	0x28,	0x08,	0x0F,	0x07,	0x00		; p_2		
.db	0x20,	0x3F,	0x3F,	0x28,	0x08,	0x0F,	0x07,	0x00		; p_2		
.db	0x0F,	0x0F,	0x00,	0x07,	0x00,	0x0F,	0x0F,	0x00		; m_2		

Ziffern:
.db	0x00,	0x00,	0x00,	0xF8,	0xFE,	0x06,	0x03,	0x83,	0xC3,	0x63,	0x33,	0x1E,	0xFE,	0xF8		; 00_1
.db	0x00,	0x00,	0x00,	0x07,	0x1F,	0x1E,	0x33,	0x31,	0x30,	0x30,	0x30,	0x18,	0x1F,	0x07		; 00_2
.db	0x00,	0x00,	0x00,	0x00,	0x00,	0x0C,	0x0C,	0x0E,	0xFF,	0xFF,	0x00,	0x00,	0x00,	0x00		; 01_1
.db	0x00,	0x00,	0x00,	0x00,	0x00,	0x30,	0x30,	0x30,	0x3F,	0x3F,	0x30,	0x30,	0x30,	0x00		; 01_2
.db	0x00,	0x00,	0x00,	0x1C,	0x1E,	0x07,	0x03,	0x03,	0x83,	0xC3,	0xE3,	0x77,	0x3E,	0x1C		; 02_1
.db	0x00,	0x00,	0x00,	0x30,	0x38,	0x3C,	0x3E,	0x37,	0x33,	0x31,	0x30,	0x30,	0x30,	0x30		; 02_2
.db	0x00,	0x00,	0x00,	0x0C,	0x0E,	0x07,	0xC3,	0xC3,	0xC3,	0xC3,	0xC3,	0xE7,	0x7E,	0x3C		; 03_1
.db	0x00,	0x00,	0x00,	0x0C,	0x1C,	0x38,	0x30,	0x30,	0x30,	0x30,	0x30,	0x39,	0x1F,	0x0E		; 03_2
.db	0x00,	0x00,	0x00,	0xC0,	0xE0,	0x70,	0x38,	0x1C,	0x0E,	0x07,	0xFF,	0xFF,	0x00,	0x00		; 04_1
.db	0x00,	0x00,	0x00,	0x03,	0x03,	0x03,	0x03,	0x03,	0x03,	0x03,	0x3F,	0x3F,	0x03,	0x03		; 04_2
.db	0x00,	0x00,	0x00,	0x3F,	0x7F,	0x63,	0x63,	0x63,	0x63,	0x63,	0x63,	0xE3,	0xC3,	0x83		; 05_1
.db	0x00,	0x00,	0x00,	0x0C,	0x1C,	0x38,	0x30,	0x30,	0x30,	0x30,	0x30,	0x38,	0x1F,	0x0F		; 05_2
.db	0x00,	0x00,	0x00,	0xC0,	0xF0,	0xF8,	0xDC,	0xCE,	0xC7,	0xC3,	0xC3,	0xC3,	0x80,	0x00		; 06_1
.db	0x00,	0x00,	0x00,	0x0F,	0x1F,	0x39,	0x30,	0x30,	0x30,	0x30,	0x30,	0x39,	0x1F,	0x0F		; 06_2
.db	0x00,	0x00,	0x00,	0x03,	0x03,	0x03,	0x03,	0x03,	0x03,	0xC3,	0xF3,	0x3F,	0x0F,	0x03		; 07_1
.db	0x00,	0x00,	0x00,	0x00,	0x00,	0x00,	0x30,	0x3C,	0x0F,	0x03,	0x00,	0x00,	0x00,	0x00		; 07_2
.db	0x00,	0x00,	0x00,	0x00,	0xBC,	0xFE,	0xE7,	0xC3,	0xC3,	0xC3,	0xE7,	0xFE,	0xBC,	0x00		; 08_1
.db	0x00,	0x00,	0x00,	0x0F,	0x1F,	0x39,	0x30,	0x30,	0x30,	0x30,	0x30,	0x39,	0x1F,	0x0F		; 08_2
.db	0x00,	0x00,	0x00,	0x3C,	0x7E,	0xE7,	0xC3,	0xC3,	0xC3,	0xC3,	0xC3,	0xE7,	0xFE,	0xFC		; 09_1
.db	0x00,	0x00,	0x00,	0x00,	0x00,	0x30,	0x30,	0x30,	0x38,	0x1C,	0x0E,	0x07,	0x03,	0x00		; 09_2

Ziff_klein:
.db	0x00,	0x00,	0x78,	0x44,	0x3C		; 0
.db	0x00,	0x00,	0x48,	0x7C,	0x40		; 1
.db	0x00,	0x00,	0x64,	0x54,	0x48		; 2
.db	0x00,	0x00,	0x44,	0x54,	0x28		; 3
.db	0x00,	0x00,	0x18,	0x10,	0x7C		; 4
.db	0x00,	0x00,	0x5C,	0x54,	0x24		; 5
.db 0x00,	0x00,	0x38,	0x54,	0x20		; 6
.db 0x00,	0x00,	0x04,	0x74,	0x1C		; 7




				





