
;Multiplikation 16 Bit mal 8 Bit:
;Mathematik: Eine 16-Bit-Zahl lsst sich in zwei 8-Bit-Zahlen auftrennen, wobei die hherwertige der beiden Zahlen mit 
;dezimal 256 oder hex 100 mal genommen wird. Fr die, die eine Erinnerung brauchen: die Dezimalzahl 1234 kann man auch 
;als die Summe aus (12*100) und 34 betrachten, oder auch als die Summe aus (1*1000), (2*100), (3*10) plus 4. 
;Die 16-Bit-Binrzahl m1 ist also gleich 256*m1M plus m1L, wobei m1M das MSB und m1L das LSB ist. Multiplikation dieser 
;Zahl mit der 8-Bit-Zahl m2 ist also mathematisch ausgedrckt:
;m1 * m2 = (256*m1M + m1L) * m2 = 256*m1M*m2 + m1L*m2

Multi:							; Multiplikation mit Periode
	push	temp1
	push	temp2
	ldi		temp2, Periode
	mul		temp, temp2			; Multipliziere LSB
	mov		R2, R0				; kopiere Ergebnis in Ergebnisregister
	mov		R3, R1
	mul		temp1, temp2		; Multiplizere MSB
	mov		R4, R1				; Kopiere MSB des Ergebnisses zum Ergebnis-Byte 3
	add		R3, R0				; Addiere LSB des Ergebnisses zum Ergebnis-Byte 2
	brcc	NoInc				; Wenn Carry nicht gesetzt, springe
	inc		R4					; erhoehe Ergebnis-Byte 3
	pop		temp2
	pop		temp1
ret
NoInc:
	pop		temp2
	pop		temp1
ret

;***************************************************************************
;*
;* "div24u" - 24/16 Bit Unsigned Division
;*    20Bit Division durch 16Bit.
;*    bergaberegister & Ergebniss in R2-4 (low-high), Divisor = Y Rest = Z
;*
;***************************************************************************
Div24u:
	ldi     YL, low(1000)
    ldi     YH, high(1000)
    rcall   div24                   ;Dividieren
ret                                               
div24:
	ldi     temp, 24				;24 * schieben
    clr     ZL						;Rest =0
    clr     ZH
dv24_1:
	lsl     R2						;Ein Bit aus dem Dividend ...  
    rol		R3						;ins Carry schieben
    rol     R4
    rol     ZL						;Carry in den Rest schieben
    rol     ZH
    brcs    dv24_3					;Bei berlauf von Rest, Sprung
    cp      ZL, YL					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     ZH, YH
    brcs    dv24_2					;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
dv24_3:
	inc     R3						;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     ZL, YL
    sbc     ZH, YH
dv24_2:
	dec     temp					;das ganze 24 mal
    brne    dv24_1
ret

;***************************************************************************************
;*				Umrechnung in ppm CO2
;*   Formel: Range(tH-2ms)/(tH+tL-4ms)
;* 
;***************************************************************************************
; tH = TimeH-TimeL, tl = TimeL
ppm:
	lds		YL, TimeLL
	lds		YH, TimeLH
	lds		XL, TimeHL
	lds		XH, TimeHH
	rjmp	Nulltest		;alle Werte 0?
_ppm:
	sub		XL, YL			;TimeH-TimeL = tH
	sbc		XH, YH
	sbiw	XL, 2			;tH - 2
	ldi		YL, low(Range)	
	ldi		YH, high(Range)
	rcall	mul16			;x Range
	lds		XL, TimeHL
	lds		XH, TimeHH
	sbiw	XL, 4			;tH+tL-4
	rcall	Div32u			;Range(tH-2ms)/(tH+tL-4ms)
rjmp	Zurueck

Nulltest:						;mu durchgefrt werden, sonst wird bei 0 Range angezeigt
	push	YL
	push	YH
	push	XL
	push	XH
	add		YL, XL
	adc		YH, XH
	brne	nicht_Null
	tst		YL
	breq	ist_Null
nicht_Null:							;Werte nicht 0, daher weiter
	pop		XH
	pop		XL
	pop		YH
	pop		YL	
rjmp	_ppm
ist_Null:							;Werte 0, daher raus
	pop		XH
	pop		XL
	pop		YH
	pop		YL	
	clr		R1
	clr		R2
	clr		R3
	clr		R4
	rcall	Div_19					;zur Speicherung des ppm_L Wertes
rjmp	Zurueck
		
;-------------------------------------------------------------------------
;Multiplikation 16*16=32 Bit. Faktor1=Y, Faktor2=Z, Ergebniss R1..R4
;-------------------------------------------------------------------------
mul16:
	ldi     temp, 16        ;16*schieben
    clr     R1				;Ergebnis (Produkt)lschen
    clr     R2
    clr		R3   
    clr     R4
mul01:
	lsl     R1				;Ergebniss schieben
    rol     R2
    rol     R3
    rol     R4
    lsl     XL              ;Herausgeschobenes Bit aus Multiplikator (ADC)..
    rol     XH              ;..entscheidet ob addiert wird
    brcc    mul02			;Wenn Bit=0 nicht addieren
    add     R1, YL			;Wenn Bit=1 Multiplikant (Formel) zum Ergebniss addieren
    adc     R2, YH
	clr		temp1	
    adc     R3, temp1
    adc     R4, temp1
mul02:
	dec     temp            ;Alle 16 Bit durch ?
    brne    mul01
ret		

;***************************************************************************
;* "div32u" - 32/16 Bit Unsigned Division
;*    32Bit Division durch 16Bit.
;*    bergaberegister & Ergebniss in R1-4 (low-high), Divisor = X Rest = Z
;***************************************************************************
Div32u:
	rcall   div32                   ;Dividieren
ret                                               
div32:
	ldi     temp, 32				;32 * schieben
    clr     ZL						;Rest = 0
    clr     ZH
dv32_1:
	lsl     R1						;Ein Bit aus dem Dividend ...  
    rol		R2						;ins Carry schieben
    rol     R3
	rol		R4
    rol     ZL						;Carry in den Rest schieben
    rol     ZH
    brcs    dv32_3					;Bei berlauf von Rest, Sprung
    cp      ZL, XL					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     ZH, XH
    brcs    dv32_2					;Bei Rest<Divisor, die eingeschobene 0 in R1 stehen lassen
dv32_3:
	inc     R1						;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     ZL, XL
    sbc     ZH, XH
dv32_2:
	dec     temp					;das ganze 32 mal
    brne    dv32_1
	rcall	Div_19					;Startwert ist 400, Wert 700 liegt auf dem 1. Pixel von Page 5, d.h. auf dem 17. Pixel (2x8+1). 
ret									;(700-400)/16 = 18,75 ~ 19, jedes Pixel stellt also 19 Werte dar.

;zur Darstellung in der Grafik werden die ppm Werte durch 19 geteilt -> ppm_L
Div_19:	
;R1 = LSB Dividend, R2 = MSB Dividend, R3 = Hifsregister, temp = Divisor, R5 = LSB Ergebnis
	push	R1
	push	R2
	push	temp
	push	temp1
	push	temp2
	in		temp2, SREG
	clr		R3
	clr		R6						;Leere Ergebnisregister
	clr		R5						;Ergebnisregister dient auch als
	inc		R5						;Zhler bis 16! Bit 1 auf 1 setzen)
	ldi		temp, 0x90
	ldi		temp1, 0x1
	cp		R1, temp				;sind R1 und R2 unter 400 (0x190)?
	cpc		R2, temp1
	brlo	Korr					;wenn ja, Korrektur
	mov		temp, R1
	mov		temp1, R2
	subi	temp, low(Minval)		;400 abziehen, da Grafik mit 400 startet
	sbci	temp1, high(Minval)
	mov		R1, temp
	mov		R2, temp1
	ldi		temp, 19
; Hier beginnt die Divisionsschleife
div8a:
	clc								;Carry-Bit leeren
	rol		R1						;nchsthheres Bit des Dividenden
	rol		R2						;in das Hilfsregister rotieren
	rol		R3						;entspricht Multipliklation mit 2
	brcs	div8b					;Eine 1 ist herausgerollt, ziehe ab
	cp		R3, temp				;Divisionsergebnis 1 oder 0?
	brcs	div8c					;berspringe Subtraktion, wenn kleiner
div8b:
	sub		R3, temp				;Subtrahiere Divisor
	sec								;Setze carry-bit, Ergebnis ist eine 1
	rjmp	div8d					;zum Schieben des Ergebnisses
div8c:
	clc								;Lsche carry-bit, Ergebnis ist eine 0
div8d:
	rol		R5						;Rotiere carry-bit in das Ergebnis
	rol		R6
	brcc	div8a					;solange Nullen aus dem Ergebnis rotieren: weitermachen
	sts		ppm_L, R5				;Wert speichern
	out		SREG, temp2
	pop		temp2
	pop		temp1
	pop		temp
	pop		R2
	pop		R1									
ret
Korr:
	ldi		temp,21
	mov		R5, temp				;Minwert 21 (400/19)
	sts		ppm_L, R5				;Wert speichern
	out		SREG, temp2
	pop		temp2
	pop		temp1
	pop		temp
	pop		R2
	pop		R1	
ret

;*************************************************************************************
; 16 Bit in BCD,   dual->BCD  nach Tietze/Schenk
; R2:R1 = HEX Wert
; R20:R19:R18 = BCD Wert
;************************************************************************************
 hexToBcd:              
	push    R18
    push    R19
    push    R20
    ldi     temp, 16
    clr     R18
    clr     R19
    clr     R20
hexToBcd1:
    lsl     R1         ; shift input value through ALL bytes
    rol     R2
    rol     R18
    rol     R19
    rol     R20
    dec     temp
	breq    hexToBcd_end
    subi    R20,-$03
    sbrs    R20,3
    subi	R20,$03
    subi    R19,-$33
    sbrs    R19,3
    subi	R19,$03
    sbrs    R19,7
    subi	R19,$30
    subi    R18,-$33
    sbrs    R18,3
    subi	R18,$03
    sbrs    R18,7
    subi	R18,$30
rjmp      hexToBcd1
hexToBcd_end:
    sts     ppmH, R19
    sts     ppmL, R18
    pop     R20
    pop     R19
    pop     R18
ret
